commit 9e9d9e94f0e0c2ae19fbd8150aea44bf521bfad6
Author: freddy77 <freddy77>
Date:   Wed Jan 27 08:31:26 2010 +0000

    add support for user/password using SSPI

diff --git a/ChangeLog b/ChangeLog
index 46e541d..0bfd60c 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Wed Jan 27 09:29:57 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c src/tds/sspi.c:
+	- add support for user/password using SSPI
+
 Wed Jan 27 09:07:13 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/sspi.c: remove useless "A" suffix
 
@@ -2211,4 +2215,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2961 2010/01/27 08:08:32 freddy77 Exp $
+$Id: ChangeLog,v 1.2962 2010/01/27 08:31:26 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index a9abcc1..efe7c8a 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.526 2010/01/23 20:25:56 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.527 2010/01/27 08:31:26 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv, SQLINTEGER odbc_version);
@@ -474,12 +474,6 @@ SQLDriverConnect(SQLHDBC hdbc, SQLHWND hwnd, SQLCHAR FAR * szConnStrIn, SQLSMALL
 		ODBC_RETURN(dbc, SQL_ERROR);
 	}
 
-	if (tds_dstr_isempty(&connection->user_name)) {
-		tds_free_connection(connection);
-		odbc_errs_add(&dbc->errs, "IM007", "Could not find UID parameter");
-		ODBC_RETURN(dbc, SQL_ERROR);
-	}
-
 	if (odbc_connect(dbc, connection) != SQL_SUCCESS) {
 		tds_free_connection(connection);
 		ODBC_RETURN_(dbc);
diff --git a/src/tds/sspi.c b/src/tds/sspi.c
index 109ac88..072fb56 100644
--- a/src/tds/sspi.c
+++ b/src/tds/sspi.c
@@ -45,7 +45,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: sspi.c,v 1.3 2010/01/27 08:08:32 freddy77 Exp $");
+TDS_RCSID(var, "$Id: sspi.c,v 1.4 2010/01/27 08:31:26 freddy77 Exp $");
 
 /**
  * \ingroup libtds
@@ -147,7 +147,7 @@ tds_sspi_handle_next(TDSSOCKET * tds, struct tds_authentication * tds_auth, size
 	out_buf.pvBuffer   = auth->tds_auth.packet;
 	out_buf.cbBuffer   = NTLMBUF_LEN;
 
-	status = sec_fn->InitializeSecurityContext(&auth->cred, &auth->cred_ctx, NULL,
+	status = sec_fn->InitializeSecurityContext(&auth->cred, &auth->cred_ctx, NULL /* TODO SPN */,
 		ISC_REQ_CONFIDENTIALITY | ISC_REQ_REPLAY_DETECT | ISC_REQ_CONNECTION,
 		0, SECURITY_NETWORK_DREP, &in_desc,
 		0, &auth->cred_ctx, &out_desc,
@@ -175,12 +175,33 @@ tds_sspi_get_auth(TDSSOCKET * tds)
 	SECURITY_STATUS status;
 	ULONG attrs;
 	TimeStamp ts;
+	SEC_WINNT_AUTH_IDENTITY identity;
+	const char *p, *user_name;
 
 	TDSSSPIAUTH *auth;
+	TDSCONNECTION *connection = tds->connection;
+
+	/* check connection */
+	if (!connection)
+		return TDS_FAIL;
 
 	if (!tds_init_secdll())
 		return NULL;
 
+	/* parse username/password informations */
+	memset(&identity, 0, sizeof(identity));
+	user_name = tds_dstr_cstr(&connection->user_name);
+	if ((p = strchr(user_name, '\\')) != NULL) {
+		identity.Flags = SEC_WINNT_AUTH_IDENTITY_ANSI;
+		identity.Password = (unsigned short *) tds_dstr_cstr(&connection->password);
+		identity.PasswordLength = tds_dstr_len(&connection->password);
+		identity.Domain = (unsigned short *) user_name;
+		identity.DomainLength = p - user_name;
+		user_name = p + 1;
+		identity.User = (unsigned short *) user_name;
+		identity.UserLength = strlen(user_name);
+	}
+
 	auth = (TDSSSPIAUTH *) calloc(1, sizeof(TDSSSPIAUTH));
 	if (!auth || !tds->connection)
 		return NULL;
@@ -188,10 +209,9 @@ tds_sspi_get_auth(TDSSOCKET * tds)
 	auth->tds_auth.free = tds_sspi_free;
 	auth->tds_auth.handle_next = tds_sspi_handle_next;
 
-	/* TODO parse user/pass and use them if available */
 	/* TODO use SPNEGO to use Kerberos if possible */
 	if (sec_fn->AcquireCredentialsHandle(NULL, (char *)"NTLM", SECPKG_CRED_OUTBOUND,
-		NULL, NULL, // ntlm->p_identity,
+		NULL, identity.Domain ? &identity : NULL,
 		NULL, NULL, &auth->cred, &ts) != SEC_E_OK) {
 		free(auth);
 		return NULL;
@@ -211,7 +231,7 @@ tds_sspi_get_auth(TDSSOCKET * tds)
 	buf.BufferType = SECBUFFER_TOKEN;
 	buf.pvBuffer   = auth->tds_auth.packet;
 
-	status = sec_fn->InitializeSecurityContext(&auth->cred, NULL, "",
+	status = sec_fn->InitializeSecurityContext(&auth->cred, NULL, "" /* TODO SPN */,
 		ISC_REQ_CONFIDENTIALITY | ISC_REQ_REPLAY_DETECT | ISC_REQ_CONNECTION,
 		0, SECURITY_NETWORK_DREP,
 		NULL, 0,

